/**
 */
package resume.model.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import resume.model.util.ModelAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support
 * Viewers. The adapters generated by this factory convert EMF adapter
 * notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}. The
 * adapters also support Eclipse property sheets. Note that most of the adapters
 * are shared among multiple instances. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class ModelItemProviderAdapterFactory extends ModelAdapterFactory
        implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
    /**
     * This keeps track of the root adapter factory that delegates to this
     * adapter factory. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ComposedAdapterFactory parentAdapterFactory;

    /**
     * This is used to implement
     * {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    protected IChangeNotifier changeNotifier = new ChangeNotifier();

    /**
     * This keeps track of all the supported types checked by
     * {@link #isFactoryForType isFactoryForType}. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected Collection<Object> supportedTypes = new ArrayList<Object>();

    /**
     * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    public ModelItemProviderAdapterFactory() {
        supportedTypes.add(IEditingDomainItemProvider.class);
        supportedTypes.add(IStructuredItemContentProvider.class);
        supportedTypes.add(ITreeItemContentProvider.class);
        supportedTypes.add(IItemLabelProvider.class);
        supportedTypes.add(IItemPropertySource.class);
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.Resume} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected ResumeItemProvider resumeItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.Resume}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createResumeAdapter() {
        if (resumeItemProvider == null) {
            resumeItemProvider = new ResumeItemProvider(this);
        }

        return resumeItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.CoverLetter} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected CoverLetterItemProvider coverLetterItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.CoverLetter}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createCoverLetterAdapter() {
        if (coverLetterItemProvider == null) {
            coverLetterItemProvider = new CoverLetterItemProvider(this);
        }

        return coverLetterItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.WorkExperience} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected WorkExperienceItemProvider workExperienceItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.WorkExperience}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createWorkExperienceAdapter() {
        if (workExperienceItemProvider == null) {
            workExperienceItemProvider = new WorkExperienceItemProvider(this);
        }

        return workExperienceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.Reference} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected ReferenceItemProvider referenceItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.Reference}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createReferenceAdapter() {
        if (referenceItemProvider == null) {
            referenceItemProvider = new ReferenceItemProvider(this);
        }

        return referenceItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.JobPosition} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected JobPositionItemProvider jobPositionItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.JobPosition}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createJobPositionAdapter() {
        if (jobPositionItemProvider == null) {
            jobPositionItemProvider = new JobPositionItemProvider(this);
        }

        return jobPositionItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.ContactInfo} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected ContactInfoItemProvider contactInfoItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.ContactInfo}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createContactInfoAdapter() {
        if (contactInfoItemProvider == null) {
            contactInfoItemProvider = new ContactInfoItemProvider(this);
        }

        return contactInfoItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.Employer} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected EmployerItemProvider employerItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.Employer}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createEmployerAdapter() {
        if (employerItemProvider == null) {
            employerItemProvider = new EmployerItemProvider(this);
        }

        return employerItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.Accomplishment} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected AccomplishmentItemProvider accomplishmentItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.Accomplishment}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createAccomplishmentAdapter() {
        if (accomplishmentItemProvider == null) {
            accomplishmentItemProvider = new AccomplishmentItemProvider(this);
        }

        return accomplishmentItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.Skill} instances. <!-- begin-user-doc --> <!--
     * end-user-doc -->
     * 
     * @generated
     */
    protected SkillItemProvider skillItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.Skill}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createSkillAdapter() {
        if (skillItemProvider == null) {
            skillItemProvider = new SkillItemProvider(this);
        }

        return skillItemProvider;
    }

    /**
     * This keeps track of the one adapter used for all
     * {@link resume.model.ReferenceItem} instances. <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected ReferenceItemItemProvider referenceItemItemProvider;

    /**
     * This creates an adapter for a {@link resume.model.ReferenceItem}. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter createReferenceItemAdapter() {
        if (referenceItemItemProvider == null) {
            referenceItemItemProvider = new ReferenceItemItemProvider(this);
        }

        return referenceItemItemProvider;
    }

    /**
     * This returns the root adapter factory that contains this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public ComposeableAdapterFactory getRootAdapterFactory() {
        return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
    }

    /**
     * This sets the composed adapter factory that contains this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
        this.parentAdapterFactory = parentAdapterFactory;
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean isFactoryForType(Object type) {
        return supportedTypes.contains(type) || super.isFactoryForType(type);
    }

    /**
     * This implementation substitutes the factory itself as the key for the
     * adapter. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Adapter adapt(Notifier notifier, Object type) {
        return super.adapt(notifier, this);
    }

    /**
     * <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object adapt(Object object, Object type) {
        if (isFactoryForType(type)) {
            Object adapter = super.adapt(object, type);
            if (!(type instanceof Class<?>) || (((Class<?>) type).isInstance(adapter))) {
                return adapter;
            }
        }

        return null;
    }

    /**
     * This adds a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void addListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.addListener(notifyChangedListener);
    }

    /**
     * This removes a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void removeListener(INotifyChangedListener notifyChangedListener) {
        changeNotifier.removeListener(notifyChangedListener);
    }

    /**
     * This delegates to {@link #changeNotifier} and to
     * {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!-- end-user-doc
     * -->
     * 
     * @generated
     */
    @Override
    public void fireNotifyChanged(Notification notification) {
        changeNotifier.fireNotifyChanged(notification);

        if (parentAdapterFactory != null) {
            parentAdapterFactory.fireNotifyChanged(notification);
        }
    }

    /**
     * This disposes all of the item providers created by this factory. <!--
     * begin-user-doc --> <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void dispose() {
        if (resumeItemProvider != null)
            resumeItemProvider.dispose();
        if (coverLetterItemProvider != null)
            coverLetterItemProvider.dispose();
        if (workExperienceItemProvider != null)
            workExperienceItemProvider.dispose();
        if (referenceItemProvider != null)
            referenceItemProvider.dispose();
        if (jobPositionItemProvider != null)
            jobPositionItemProvider.dispose();
        if (contactInfoItemProvider != null)
            contactInfoItemProvider.dispose();
        if (employerItemProvider != null)
            employerItemProvider.dispose();
        if (accomplishmentItemProvider != null)
            accomplishmentItemProvider.dispose();
        if (skillItemProvider != null)
            skillItemProvider.dispose();
        if (referenceItemItemProvider != null)
            referenceItemItemProvider.dispose();
    }

}
